;;  EMSAsm.s written by Ed Mandy (emandy@atcorp.com)
;;     Much of this code has been taken from other sources

	.area	_BSS
Offset::
	.ds	1
CPUType::
	.ds	1

;#define DMG_TYPE 0x01 /* Original GB or Super GB */
;#define MGB_TYPE 0xFF /* Pocket GB or Super GB 2 */
;#define CGB_TYPE 0x11 /* Color GB */

	.area	_CODE


;;
;;  *****  Begin EMS offset setting code
;;
;;  Call setEMSOffset(char offset) to set the offset and restart at that offset
;;
_setEMSOffset::        ;new name
   CALL #copy_set_EMS_offset
   LDA HL,3(SP)	; Skip return address and registers
   LD  A,(HL)	; make sure CPUType holds the GB type
   LD  (CPUType), A
   DEC HL
   LD  A,(HL)	; make sure (Offset) holds the offset to switch to
   LD  (Offset), A
   JP  0xD000


set_EMS_offset::
        di
        ld      a,#0
        ldh     (#0xFF),a
        ld      a,#0x0A
        ld      (#0x0000),a

; Switch to cart bank reconfigure mode


   ld   a,(Offset)      ;was C003
   sla  a                     
   ld   (#0x2000),a  ;ROM select 
   ld   a,#0xA5                  
   ld   (#0x1000),a  ;RAM enable 
   ld   a,(#0x4148)  ;ROM Size
   cp   #0x0F                    
   jr   nc,.2DDA$
   ld   a,(#0x4148)  ;ROM Size
   and  #0x07                    
   xor  #0x07                    
   ld   d,a                   
   jr   .2DDD$
.2DDA$:
   ld   a,#0x01                  
   ld   d,a   
.2DDD$:
   ld   e, #0x30                  
   ld   a,(#0x4149)  ;RAM Size
   and  #0xFF                   
   jr   nz,.2DE8$               
   jr   .2E04$                  
.2DE8$:
   ld   a,(#0x4149)  ;RAM Size
   cp   #0x01                    
   jr   nz,.2DF3$
   ld   e,#0x20                  
   jr   .2E04$
.2DF3$:
   ld   a,(#0x4149)  ;RAM Size
   dec  a                     
   xor  #0x03                    
   rlc  a                     
   rlc  a                     
   rlc  a                     
   rlc  a                     
   and  #0x30                    
   ld   e,a 
.2E04$:                  
   ld   a,d                   
   or   e                     
   ld   (#0x7000),a  ;?          
   ld   a,#0x98                  
   ld   (#0x1000),a  ;RAM enable 

; Exit cart bank reconfigure mode

        ld      a,#0x0A
        ld      (0x0000),a

; Clear video ram
   LD HL,#0x8000
   LD DE,#0x2000
   LD A, #0x00
   LDH (#0x40), A						;.LCDC		= 0x40	; LCD control
.ClrLCDLoop$:
   LDH A,(#0x41)             ;.STAT		= 0x41	; LCD status
   AND #0x02
   JR NZ, .ClrLCDLoop$
   LD A, #0x00
   LD (HL+),A
   DEC DE
   LD A, D
   OR E
   JR NZ, .ClrLCDLoop$

; Setup default video mode
        ld      a,#0x91
        ldh     (0x40),a

.2E2F$:
   ldh  a,(#0x41)
   and  #0x01
   jr   nz,.2E2F$
.2E35$:
   ldh  a,(#0x41)
   and  #0x01
   jr   z,.2E35$

; Initialize the stack

        ld      sp,#0xfffe

; Execute selected game in the multicart
	LD A, (CPUType)	;(based on GB Type)  (CGB=0x11 GB=0x01 GBP=0xFF) [PVoice.s did 0x00]
        jp      0x0100
end_of_set_EMS_offset:

copy_set_EMS_offset::
   LD HL, #set_EMS_offset
   LD DE, #end_of_set_EMS_offset
   ;
   LD A,E         ; do DE=end_of_set_PV_offset-set_PV_offset (or DE-HL)
   SUB  L         ; E = A - L where A = E
   LD E,A
   LD A,D
   SBC  H         ; Sub and use the carry flag
   LD D,A         ; D = A - H where A = D
   ;					; Now, DE = the number of bytes to copy to RAM(0xD000)
   LD BC, #0xD000
.copy_EMS_loop$:
   LD A,(HL+)
   LD (BC),A
   INC BC
   DEC DE
   LD A, E
   OR D
   JP NZ,.copy_EMS_loop$
   RET

